#
#	Rules for all builds.
#	Created 12-NOV-2002		Richard B. Johnson
#
PWD :=	$(shell pwd)
SYLIB = /lib
START = $(SYLIB)/start.o
MAP   = Shared.Map
SLIBC = crtl.so
SLIBM = libm.so
LIBSO = $(SYLIB)/$(SLIBC) # C Runtime shared object
LIBSM = $(SYLIB)/$(SLIBM) # C Math shared object
LIBLD = $(SYLIB)/ld-linux.so
STATI = libstatic.a
LSTAT = $(SYLIB)/$(STATI)
SLINK = -dynamic-linker $(LIBLD) -rpath $(SYLIB) -rpath-link $(SYLIB)
SLINK += -m elf_i386
CC = gcc -Wall -O3 -fomit-frame-pointer -fno-builtin -nostartfiles -march=i586
CC += -fno-strict-aliasing -fexpensive-optimizations -pipe
LD = ld -i -export-dynamic 

%.os:%.c
		$(CC) -shared -c -o $@ $<
		strip -x -R .note -R .comment $@

%.o:%.c
		$(CC) -c -o $@ $<
		strip -x -R .note -R .comment $@

%.o:%.S
		as --strip-local-absolute -o $@ $<

%.os:%.S
		as --strip-local-absolute -o $@ $<

%.o:%.s
		as --strip-local-absolute -o $@ $<


