#-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#
#  Copyright(c)  2005  Richard B. Johnson
#
#  This program may be distributed under the GNU Public License
#  version 2, as published by the Free Software Foundation, Inc.,
#  59 Temple Place, Suite 330 Boston, MA, 02111.
#
#-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#
#  File basename.S              Created 03-JUN-2005   Richard B. Johnson
#
#  Given an input pointer to an array of chars, this procedure
#  returns a pointer to the character following the last slash.
#  Therefore, with a string of /usr/src/linux-2.9.22/include/my.h,
#  it will return a pointer to 'my.h'.
#

BUFFR = 0x08
.extern strlen  .function
.section .text
basename:
__xpg_basename:
        pushl   %ebx                    # Save precious register
        movl    BUFFR(%esp), %ebx       # Pointer to buffer
        pushl   %ebx                    # Pointer to strlen
        call    strlen                  # Get string length
        addl    $0x04, %esp             # Level stack
        movl    %eax, %ecx              # Return value is the count
        incl    %ecx                    # Count back to offset zero
        addl    %eax, %ebx              # Last byte
1:      cmpb    $0x2f, (%ebx)           # Check slash value, 0x2f
        leal    -0x01(%ebx), %ebx       # Next address
        loopnz  1b
        jnz     2f                      # It was found
        incl    %ebx                    # Not found at all
2:      incl    %ebx                    # Adjust past the slash 
        movl    %ebx, %eax              # Return pointer
        popl    %ebx
        ret
.size   basename,.-basename
.type   basename,@function
.weak   basename
.size   __xpg_basename,.-__xpg_basename
.type   __xpg_basename,@function
.weak   __xpg_basename
# -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
# -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
# -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
