#-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#
#  Copyright(c)  2003  Richard B. Johnson
#
#  This program may be distributed under the GNU Public License
#  version 2, as published by the Free Software Foundation, Inc.,
#  59 Temple Place, Suite 330 Boston, MA, 02111.
#
#-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#
#   This is an interface to the Linux Operating System.
#   It is callable from 'C', and is part of a 'C'
#   runtime library,
#
#   Created 02-APR-2001   Richard B. Johnson  RichardBJohnson@comcast.net
#

MAX_ERROR = 255
.extern __errno_location        .function
.include "syscall.h"
.section        .text
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       Macro for functions that take one parameter.
#
.macro  FUNCT_ONE       name,value
.global \name
.type   \name,@function
.align  0x04
\name:  movl    $\value, %eax
        jmp     one_parm
.size   \name,.-\name
.endm
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       Macro for functions that take two parameters.
#
.macro  FUNCT_TWO       name,value
.global \name
.type   \name,@function
.align  0x04
\name:  movl    $\value, %eax
        jmp     two_parms
.size   \name,.-\name
.endm
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       Macro for functions that take three parameters.
#
.macro  FUNCT_THREE     name,value
.global \name
.type   \name,@function
.align  0x04
\name:  movl    $\value, %eax
        jmp     three_parms
.size   \name,.-\name
.endm
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       Macro for functions that take four parameters.
#
.macro  FUNCT_FOUR      name,value
.global \name
.type   \name,@function
.align  0x04
\name:  movl    $\value, %eax
        jmp     four_parms
.size   \name,.-\name
.endm
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       Macro for functions that take five parameters.
#
.macro  FUNCT_FIVE      name,value
.global \name
.type   \name,@function
.align  0x04
\name:  movl    $\value, %eax
        jmp     five_parms
.size   \name,.-\name
.endm
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       Macro for functions that take six parameters.
#
.macro  FUNCT_SIX       name,value
.global \name
.type   \name,@function
.align  0x04
\name:  movl    $\value, %eax
        jmp     six_parms
.size   \name,.-\name
.endm
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       Macro for functions that take no parameters.
#
.macro  FUNCT_VOID      name,value
.global \name
.type   \name,@function
.align  0x04
\name:  movl    $\value, %eax
        jmp     no_parms
.size   \name,.-\name
.endm
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#   This impliments exit(int); It executes anything registered by
#   atexit() before it calls the system exit function with a return
#   code. The rules state that these functions must be called in
#   the reverse-order of their registration.
#
.global exit
.type   exit,@function

exit:   movl    $__funct_end, %esi      # Start at most recent
1:      leal    -0x04(%esi), %esi       # Ready next
        movl    (%esi), %ebx            # Get what's there
        orl     %ebx,%ebx               # Check for possible function
        jz      2f                      # Nothing yet
        call    *%ebx                   # Call the function
2:      cmpl    $__funct, %esi          # Start of the list?
        jnz     1b                      # Not at the start yet
        movl    0x04(%esp), %ebx        # Exit code
        movl    $__NR_exit, %eax        # Function
        int     $0x80
.size   exit,.-exit
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#   This impliments int atexit(void(*funct)(void));
#
.global atexit
.type   atexit,@function
atexit: pushl   %esi                    # Save index register
        movl    $__funct, %esi          # Point to top of list
1:      cmpl    $0,(%esi)               # See what's there
        jnz     2f                      # It's being used
        movl    0x08(%esp), %eax        # Get function pointer
        movl    %eax,(%esi)             # Set pointer
        xorl    %eax,%eax               # Return value
        jmp     3f                      # Home, James
2:      leal    0x04(%esi), %esi        # Ready next
        cmpl    $__funct_end, %esi      # Check end of list
        jb      1b                      # Continue
        orl     $-1,%eax                # Show error
3:      popl    %esi
        ret
.size   atexit,.-atexit
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This impliments int quotactl(int cmd, char *special,
#                                gid_t id, caddr_t addr)
#
FUNCT_FOUR      quotactl,__NR_quotactl
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This impliments int clone(int (*fn)(void *), void *child_stack,
#         int flags, void *arg)
#
FUNCT_FOUR      clone,__NR_clone
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This impliments profil(unsigned short *, size_t buf_size,
#                             size_t offset, unsigned int scale)
#
FUNCT_FOUR      profil,__NR_profil
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This impliments wait4(pid_t pid, int *status, int opts,
#                                        struct rusage *ru)
#
FUNCT_FOUR      wait4,__NR_wait4
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This impliments ptrace(int request, pid_t pid, int addr, int data)
#
FUNCT_FOUR      ptrace,__NR_ptrace
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#  This impliments:
#       int query_module(const char *name, int which,
#       void *buf, size_t bufsize, size_t *ret);
#
FUNCT_FIVE      query_module,__NR_query_module
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This impliments int select(int nr, fd_set *rfd, fd_set *wfd,
#                                          fd_set *efd struct timeval *tv)
#
FUNCT_FIVE      select,__NR__newselect
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#   This impliments mount(const char *, const char *mpt,
#                                       const char *fstype,
#                                       unsigned long rw_flag,
#                                       const void *data);
#
FUNCT_FIVE      mount,__NR_mount
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#   This impliments int ipc(unsigned int call, int first,
#                                       int second, int third
#                                       int fourth, void *fifth);
#
.global __ipc
.type   __ipc,@function
__ipc:  jmp     ipc
FUNCT_SIX       ipc,__NR_ipc
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#   This impliments caddr_t mmap(caddr_t addr, size_t len,
#                                       int prot, int flags
#                                       int fd, off_t offset);
#
.global mmap
.type   mmap,@function
mmap:   shrl    $0x0c, 0x18(%esp)       # Sixth parameter
                                        # Fall through
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#   This impliments caddr_t mmap2(caddr_t addr, size_t len,
#                                       int prot, int flags
#                                       int fd, off_t offset);
#
FUNCT_SIX       mmap2,__NR_mmap2
.size   mmap,.-mmap
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#   This impliments caddr_t __mmap2(caddr_t addr, size_t len,
#                                       int prot, int flags
#                                       int fd, off_t offset);
#
FUNCT_SIX       __mmap,__NR_mmap
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#  This impliments __xmknod();
#
.global __xmknod
.type   __xmknod,@function
__xmknod:
        pushl   %ebx
        movl    0x08(%esp), %eax        # Find how to use parameter
        movl    0x0c(%esp), %ebx        # First parameter
        movl    0x10(%esp), %ecx        # Second parameter
        movl    0x14(%esp), %edx        # Third parameter
        cmpl    $1, %eax                # Do we de-reference?
        jnz     1f                      # Nope, not a pointer
        movl    (%edx), %edx            # Yes, dereference the pointer
1:      movl    $__NR_mknod, %eax       # Function number
        int     $0x80
        jmp     clean_up
.size   __xmknod,.-__xmknod
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does munlock(void *mem, size_t len);
#
FUNCT_TWO       munlock,__NR_munlock
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does mlock(void *mem, size_t len);
#
FUNCT_TWO       mlock,__NR_mlock
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int fstat(int fd, struct stat *)
#
FUNCT_TWO       sys_fstat,__NR_fstat
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int oldlstat(const char *nam, struct *)
#
FUNCT_TWO       oldlstat,__NR_oldlstat
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int flock(int fd, int operation)
#
FUNCT_TWO       flock,__NR_flock
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int bdflush(int funct, void *stuff)
#
FUNCT_TWO       bdflush,__NR_bdflush
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int nanosleep(struct timespec *tim, struct timespec *rem)
#
FUNCT_TWO       nanosleep,__NR_nanosleep
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int init_module(char *name, struct module *image)
#
FUNCT_TWO       init_module,__NR_init_module
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int create_module(char *name, size_t len)
#
FUNCT_TWO       create_module,__NR_create_module
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int setdomainname(char *name, size_t len)
#
FUNCT_TWO       setdomainname,__NR_setdomainname
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int getitimer(int which, struct itimerval *args)
#
FUNCT_TWO       getitimer,__NR_getitimer
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int socketcall(int call, unsigned long *args)
#
FUNCT_TWO       socketcall,__NR_socketcall
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int statfs(const char *pathname, struct statfs *buf)
#
FUNCT_TWO       statfs,__NR_statfs
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int fstatfs(int fd, struct statfs *buf)
#
FUNCT_TWO       fstatfs,__NR_fstatfs
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int getpriority(int which, int who)
#
FUNCT_TWO       getprioirity,__NR_getpriority
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int fchmod(int fd, mode_t mode)
#
FUNCT_TWO       fchmod,__NR_fchmod
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int ftruncate(int fd, size_t len)
#
FUNCT_TWO       ftruncate,__NR_ftruncate
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int truncate(const char *, size_t len)
#
FUNCT_TWO       truncate,__NR_truncate
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int munmap(caddr_t addr, size_t len)
#
FUNCT_TWO       munmap,__NR_munmap
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int swapon(const char *dev, int flags)
#
FUNCT_TWO       swapon,__NR_swapon
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int symlink(const char *old_name, const char *new_name)
#
FUNCT_TWO       symlink,__NR_symlink
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int getgroups(size_t len, gid_t list[])
#
FUNCT_TWO       getgroups,__NR_getgroups
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int setgroups(size_t len, gid_t list[])
#
FUNCT_TWO       setgroups,__NR_setgroups
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int settimeofday(struct timeval *tv, struct timezone *tz)
#
FUNCT_TWO       settimeofday,__NR_settimeofday
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int gettimeofday(struct timeval *tv, struct timezone *tz)
#
FUNCT_TWO       gettimeofday,__NR_gettimeofday
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int getrusage(int who, struct rusage *ru )
#
FUNCT_TWO       getrusage,__NR_getrusage
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int setrlimit(int resource, struct rlimit *sr )
#
FUNCT_TWO       setrlimit,__NR_setrlimit
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int getrlimit(int resource, struct rlimit *sr )
#
FUNCT_TWO       getrlimit,__NR_getrlimit
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int sethostname(const char *name, size_t len)
#
FUNCT_TWO       sethostname,__NR_sethostname
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int setregid(gid_t rgid, gid_t egid)
#
FUNCT_TWO       setregid,__NR_setregid
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int setreuid(uid_t ruid, uid_t euid)
#
FUNCT_TWO       setreuid,__NR_setreuid
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int dup2(int, int)
#
FUNCT_TWO       dup2,__NR_dup2
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int ulimit(whatever, whatever)
#
FUNCT_TWO       ulimit,__NR_ulimit
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int ustat(dev_t dev, struct stat *ubuf)
#
FUNCT_TWO       ustat,__NR_ustat
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int setpgid(pid_t pid, gid_t gid)
#
FUNCT_TWO       setpgid,__NR_setpgid
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int mpx(int, int flag);
#
FUNCT_TWO       mpx,__NR_mpx
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int lock(char *file, int flag);
#
FUNCT_TWO       lock,__NR_lock
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int signal(signal, handler)
#
FUNCT_TWO       signal,__NR_signal
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int mkdir(const char *name, mode_t mode)
#
FUNCT_TWO       mkdir,__NR_mkdir
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int rename(char *old, char *new)
#
FUNCT_TWO       rename,__NR_rename
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int kill(pid, signal)
#
FUNCT_TWO       kill,__NR_kill
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int access(const char *fname, int which)
#
FUNCT_TWO       access,__NR_access
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does stty(...)
#
FUNCT_TWO       stty,__NR_stty
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does gtty(...)
#
FUNCT_TWO       gtty,__NR_gtty
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does munlockall(void);
#
FUNCT_VOID      munlockall,__NR_munlockall
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does sched_yield(void);
#
FUNCT_VOID      sched_yield,__NR_sched_yield
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int vfork(void);
#
FUNCT_VOID      vfork,__NR_vfork
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int fork(void);
#
FUNCT_VOID      fork,__NR_fork
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int vhangup(void);
#
FUNCT_VOID      vhangup,__NR_vhangup
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int siggetmask(void);
#
FUNCT_VOID      siggetmask,__NR_sgetmask
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int setsid(void);
#
FUNCT_VOID      setsid,__NR_setsid
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int pause(void);
#
FUNCT_VOID      pause,__NR_pause
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for gid_t getpgrp(void);
#
FUNCT_VOID      getpgrp,__NR_getpgrp
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for gid_t getppid(void);
#
FUNCT_VOID      getppid,__NR_getppid
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for gid_t geteuid(void);
#
FUNCT_VOID      geteuid,__NR_geteuid
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for gid_t getegid(void);
#
FUNCT_VOID      getegid,__NR_getegid
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for gid_t getgid(void);
#
FUNCT_VOID      getgid,__NR_getgid
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This does int sync(void);
#
FUNCT_VOID      sync,__NR_sync
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#   This does pid_t getpid(void);
#
FUNCT_VOID      getpid,__NR_getpid
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#   This does pid_t getuid(void);
#
FUNCT_VOID      getuid,__NR_getuid
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#    This impliments int poll(struct pollfd *, unsigned int nfds, int timeout);
#
FUNCT_THREE     poll,__NR_poll
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#    This impliments int getdents(int fd, struct dirent *, size_t cpunt);
#
FUNCT_THREE     sys_getdents,__NR_getdents
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#    This impliments int sysfs(int option, void *stuff, void *stuff);
#
FUNCT_THREE     sysfs,__NR_sysfs
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#    This impliments int sigprocmask(int how, sigset_t *set, sigset_t *old);
#
FUNCT_THREE     sigprocmask,__NR_sigprocmask
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This impliments int mprotect(caddr_t addr, size_t len, int prot);
#
FUNCT_THREE     mprotect,__NR_mprotect
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This impliments int setitimer(int which, struct itimerval *value,
#                                struct itimerval *ovalue)
#
FUNCT_THREE     setitimer,__NR_setitimer
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This impliments int sys_syslog(int type, char *buf, size_t len)
#
FUNCT_THREE     sys_syslog,__NR_syslog
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This impliments int ioperm(long from, long to, int on_off)
#
FUNCT_THREE     ioperm,__NR_ioperm
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This impliments int setpriority(int which, int who, int priority)
#
FUNCT_THREE     setpriority,__NR_setpriority
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This impliments int fchown(int fd, uid_t uid, gid_t gid)
#
FUNCT_THREE     fchown,__NR_fchown
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This impliments int readdir(int fd, struct dirent *dp, size_t count)
#
FUNCT_THREE     sys_readdir,__NR_readdir
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This impliments int reboot(int magic, int magic_too, int flag)
#
FUNCT_THREE     reboot,__NR_reboot
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This impliments int readlink(const char *, char *buf, size_t len)
#
FUNCT_THREE     readlink,__NR_readlink
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This impliments int sigaction(int sig, struct sigaction *act,
#                                     struct sigaction *old)
#
FUNCT_THREE     sigaction,__NR_sigaction
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This impliments int fcntl(int fd, int what, unsigned long arg)
#
FUNCT_THREE     fcntl,__NR_fcntl
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This impliments int ioctl(int fd, int what, void *dat)
#
FUNCT_THREE     ioctl,__NR_ioctl
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#   This impliments  chown(const char *pathname, uid_t uid, gid_t gid)
#
FUNCT_THREE     chown,__NR_chown
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#   This impliments lchown(const char *pathname, uid_t uid, gid_t gid)
#
FUNCT_THREE     lchown,__NR_lchown
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#   This makes our own Mknod to test primatives.
#
FUNCT_THREE     Mknod,__NR_mknod
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#  This impliments execve(const char *n, const char *argv[], const char *env[])
#
FUNCT_THREE     execve,__NR_execve
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#  This impliments waitpid(pid, int *status, int options);
#
FUNCT_THREE     waitpid,__NR_waitpid
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#  This impliments write(fd, buf, len)
#
FUNCT_THREE     write,__NR_write
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#  This impliments read(fd, buf, len)
#
FUNCT_THREE     read,__NR_read
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#  This impliments open(const char *pathname, int mode, int attributes)
#
FUNCT_THREE     open,__NR_open
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#  This impliments lseek(int fd, off_t offset, int whence)
#
FUNCT_THREE     lseek,__NR_lseek
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       Global error code.
#
error:  pushl   %eax                    # Save error code
        call    __errno_location        # Find out where to put it
        popl    %edx                    # Restore error code
        negl    %edx                    # Remove sign
        movl    %edx, (%eax)            # Save it
        orl     $-1, %eax               # FAIL return value
        ret
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This cleans up and exits
#
clean_up:
        popl    %ebx
        cmpl    $-MAX_ERROR,%eax
        jnc     error
        ret
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
no_parms:
        int     $0x80
        cmpl    $-MAX_ERROR, %eax
        jnc     error
        ret
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for functions that take one parameter.
#
one_parm:
        pushl   %ebx
        movl    0x08(%esp), %ebx        # First parameter
        int     $0x80                   # Fall through
        jmp     clean_up
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for functions that take two params.
#
two_parms:
        pushl   %ebx
        movl    0x08(%esp), %ebx        # First parameter
        movl    0x0c(%esp), %ecx        # Second parameter
        int     $0x80
        jmp     clean_up
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#  This is for functions that take 3 parameters.
#
three_parms:
        pushl   %ebx
        movl    0x08(%esp), %ebx        # First parameter
        movl    0x0c(%esp), %ecx        # Second parameter
        movl    0x10(%esp), %edx        # Third parameter
        int     $0x80
        jmp     clean_up
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#  This is for functions that take 4 parameters.
#
four_parms:
        pushl   %ebx
        pushl   %esi
        movl    0x0c(%esp), %ebx        # First parameter
        movl    0x10(%esp), %ecx        # Second parameter
        movl    0x14(%esp), %edx        # Third parameter
        movl    0x18(%esp), %esi        # Fourth parameter
        int     $0x80
        popl    %esi
        jmp     clean_up
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#  This is for functions that take 5 parameters.
#
five_parms:
        pushl   %ebx
        pushl   %esi
        pushl   %edi
        movl    0x10(%esp), %ebx        # First parameter
        movl    0x14(%esp), %ecx        # Second parameter
        movl    0x18(%esp), %edx        # Third parameter
        movl    0x1c(%esp), %esi        # Fourth parameter
        movl    0x20(%esp), %edi        # Fifth parameter
        int     $0x80
        popl    %edi
        popl    %esi
        jmp     clean_up
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#  This is for functions that take 6 parameters.
#
six_parms:
        pushl   %ebx
        pushl   %esi
        pushl   %edi
        pushl   %ebp
        movl    0x14(%esp), %ebx        # First parameter
        movl    0x18(%esp), %ecx        # Second parameter
        movl    0x1c(%esp), %edx        # Third parameter
        movl    0x20(%esp), %esi        # Fourth parameter
        movl    0x24(%esp), %edi        # Fifth parameter
        movl    0x28(%esp), %ebp        # Sixth parameter
        int     $0x80
        popl    %ebp
        popl    %edi
        popl    %esi
        jmp     clean_up
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#  This impliments oldstat()
#
FUNCT_TWO       oldstat,__NR_oldstat
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This impliments stat()
#
FUNCT_TWO       sys_stat,__NR_stat
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This impliments lstat()
#
FUNCT_TWO       sys_lstat,__NR_lstat
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This impliments int utime(const char *fname, utimbuf *buf)
#
FUNCT_TWO       utime,__NR_utime
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#  This impliments _break()
#
FUNCT_TWO       _break,__NR_break
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#   This impliments char *getcwd(char *buf, size_t len);
#
FUNCT_TWO       getcwd,__NR_getcwd
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#   This impliments chmod(const char *pathname, mode_t mode)
#
FUNCT_TWO       chmod,__NR_chmod
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#   This impliments link(const char *old, const char *new)
#
FUNCT_TWO       link,__NR_link
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#   This impliments creat(const char *pathname, int mode);
#
FUNCT_TWO       creat,__NR_creat
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is int umount2(const char *, int flags)
#
FUNCT_TWO       umount2,__NR_umount2
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is mlockall(size_t len);
#
FUNCT_ONE       mlockall,__NR_mlockall
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for int personality(unsigned long whatever);
#
FUNCT_ONE       personality,__NR_personality
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for int fchdir(int fd);
#
FUNCT_ONE       fchdir,__NR_fchdir
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for int get_kernel_syms(struct kernel_sym *table);
#
FUNCT_ONE       get_kernel_syms,__NR_get_kernel_syms
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for int delete_module(char *name);
#
FUNCT_ONE       delete_module,__NR_delete_module
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for int adjtimex(struct timex *ptr);
#
FUNCT_ONE       adjtimex,__NR_adjtimex
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for int sigreturn(unsigned long __unused);
#
FUNCT_ONE       sigreturn,__NR_sigreturn
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for int fsync(int fd);
#
FUNCT_ONE       fsync,__NR_fsync
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for int sysinfo(struct sysinfo *sp);
#
FUNCT_ONE       sysinfo,__NR_sysinfo
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for int iopl(int nr);
#
FUNCT_ONE       iopl,__NR_iopl
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for int swapoff(const char *name);
#
FUNCT_ONE       swapoff,__NR_swapoff
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for int uselib(const char *name);
#
FUNCT_ONE       uselib,__NR_uselib
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for int uname(struct utsname *uts);
#
FUNCT_ONE       uname,__NR_uname
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for int sigpending(sigset_t *set);
#
FUNCT_ONE       sigpending,__NR_sigpending
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for int sigsuspend(sigset_t *set);
#
FUNCT_ONE       sigsuspend,__NR_sigsuspend
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for int sigsetmask(int mask);
#
FUNCT_ONE       sigsetmask,__NR_ssetmask
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for int chroot(const char *path);
#
FUNCT_ONE       chroot,__NR_chroot
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for int umask(int mask)
#
FUNCT_ONE       umask,__NR_umask
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for getpgid(pid_t pid);
#
FUNCT_ONE       getpgid,__NR_getpgid
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for acct(const char *fname)
#
FUNCT_ONE       acct,__NR_acct
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for setgid(gid_t)
#
FUNCT_ONE       setgid,__NR_setgid
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is int brk(void *data_end). This returns "negative"
#       numbers so we can't use the macro.
#
.global brk
.type   brk,@function
brk:    pushl   %ebx
        movl    0x08(%esp), %ebx        # First parameter
        movl    $__NR_brk, %eax         # Function call
        int     $0x80
        popl    %ebx
        ret
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#               Don't know
#
FUNCT_ONE       prof,__NR_prof
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for int times(*timebuf);
#
FUNCT_ONE       times,__NR_times
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for int pipe(int *);
#
FUNCT_ONE       pipe,__NR_pipe
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for int dup(int)
#
FUNCT_ONE       dup,__NR_dup
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for int rmdir(const char *pathname)
#
FUNCT_ONE       rmdir,__NR_rmdir
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is for int ftime(struct timeb *)
#
#FUNCT_ONE      ftime,__NR_ftime
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This impilments int nice(int);
#
FUNCT_ONE       nice,__NR_nice
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This impliments time(time_t *tp)
#
FUNCT_ONE       time,__NR_time
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is int alarm(time_t)
#
FUNCT_ONE       alarm,__NR_alarm
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is int setuid(uid_t)
#
FUNCT_ONE       setuid,__NR_setuid
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is int stime(time_t *)
#
FUNCT_ONE       stime,__NR_stime
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This is int umount(const char *)
#
FUNCT_ONE       umount,__NR_umount
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This impliments chdir(const char *pathname)
#
FUNCT_ONE       chdir,__NR_chdir
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This impliments remove(const char *pathname);
#
FUNCT_ONE       remove,__NR_unlink
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This impliments unlink(const char *pathname);
#
FUNCT_ONE       unlink,__NR_unlink
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#  This impliments close(int fd)
#
FUNCT_ONE       close,__NR_close
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#  This impliments msync(void *, size_t, int);
#
FUNCT_THREE     msync,__NR_msync
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#  This impliments int pivot_root(const char *new_root, const char *old_root);
#
FUNCT_TWO       pivot_root,__NR_pivot_root
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This inpliments time_t sleep(time_t seconds);
#
.global sleep
.type   sleep,@function
sleep:  pushl   %ebx
        movl    0x08(%esp), %eax        # Get time in seconds
        subl    $0x08, %esp             # Make room for two vars
        movl    %esp, %ebx              # Point to lowest word
        movl    %eax, (%ebx)            # Insert seconds
        movl    $0, 0x04(%ebx)          # Insert nanoseconds
        pushl   %ebx                    # Time to wait
        pushl   %ebx                    # Where to write remainder
        call    nanosleep               # Call existing function
        movl    (%ebx), %eax            # Get seconds remaining
        addl    $0x10, %esp             # Level stack
        popl    %ebx                    # Restore
        ret
.size   sleep,.-sleep
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
.global usleep
.type   usleep,@function
usleep: pushl   %ebx
        movl    0x08(%esp), %eax        # Get time in microseconds
        xorl    %edx, %edx              # Clear
        movl    $1000, %ecx             # Multipier
        mull    %ecx                    # Make nanoseconds
        xorl    %edx, %edx              # Clear
        movl    $1000000000, %ecx       # Divisor (nano = 9 zeros)
        divl    %ecx                    # EAX= seconds, EDX = modulus
        subl    $0x08, %esp             # Make room for two vars
        movl    %esp, %ebx              # Point to lowest word
        movl    %eax, (%ebx)            # Insert seconds
        movl    %edx, 0x04(%ebx)        # Insert nanoseconds
        pushl   %ebx                    # Time to wait
        pushl   %ebx                    # Where to write remainder
        call    nanosleep               # Call existing function
        movl    (%ebx), %eax            # Get seconds remaining
        addl    $0x10, %esp             # Level stack
        popl    %ebx                    # Restore
        ret

.size   usleep,.-usleep
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This impliments void *sbrk(long incr);
#
.global sbrk
.type   sbrk,@function
sbrk:   pushl   %ebx
        movl    (__brk_addr), %ebx      # Save current
        movl    0x08(%esp), %eax        # The morecore amount
        addl    %ebx, %eax              # New offset we want
        pushl   %eax                    # Push the parameter
        call    brk                     # Call the function
        addl    $0x04, %esp             # Level the stack
        cmpl    $-1,%eax                # Check for error
        jz      1f                      # Call failed
        movl    %eax, (__brk_addr)      # Set new break address
        movl    %ebx, %eax              # Return new writable area
1:      popl    %ebx
        ret
.size   sbrk,.-sbrk
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This impliments int wait((int *)status);
#
.global wait
.type   wait,@function
wait:   movl    0x04(%esp), %eax        # Get passed pointer
        pushl   $0x00                   # Options
        pushl   %eax                    # Pointer for status
        pushl   $-1                     # My children
        call    waitpid                 # Call the function
        addl    $0x0c, %esp             # Level stack
        ret
.size   wait,.-wait
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       This impliments int wait3(int *status, int options, struct rusage *);
#
.global wait3
.type   wait3,@function
wait3:  pushl   %ebx
        pushl   %esi
        movl    $-1, %ebx               # First parameter
        movl    0x0c(%esp), %ecx        # Second parameter
        movl    0x10(%esp), %edx        # Third parameter
        movl    0x14(%esp), %esi        # Fourth parameter
        movl    $__NR_wait4, %eax       # Function number
        int     $0x80                   # Call the kernel
        popl    %esi                    # Level stack
        jmp     clean_up
.size   wait3,.-wait3
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
.global __getpagesize
.type   __getpagesize,@function
__getpagesize:
        movl    $0x1000, %eax
        ret
.size   __getpagesize,.-__getpagesize
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
.end

