#-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#
#  Copyright(c)  2001  Richard B. Johnson
#
#  This program may be distributed under the GNU Public License
#  version 2, as published by the Free Software Foundation, Inc.,
#  59 Temple Place, Suite 330 Boston, MA, 02111.
#
#-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#
#       This is the entry point, usually the first thing in the text
#       segment. The SVR4/i386 ABI (pages 3-31, 3-32) says that upon
#       entry most registers' values are unspecified, except for:
#
#   %edx        Contains a function pointer to be registered with `atexit'.
#               This is how the dynamic linker arranges to have DT_FINI
#               functions called for shared libraries that have been loaded
#               before this code runs.
#
#   %esp        The stack contains the arguments and environment:
#               (%esp)                  argc
#               4(%esp)                 argv[0]
#               ...
#               (4*argc)(%esp)          NULL
#               (4*(argc+1))(%esp)      envp[0]
#               ...
#                                       NULL
#
.extern __setup_stdio   .function
.extern brk             .function
.extern time            .function
.extern srand           .function
.extern main            .function
.section .text
_start: cld
        xorl    %ebp,%ebp               # Clear frame pointer
        popl    %eax                    # Pop the argument count
        movl    %esp, %ecx              # This is argv[]
        movl    %eax, %ebx              # Save argument count
        incl    %eax                    # Argument count++
        shll    $2,%eax                 # Times 4
        addl    %ecx, %eax              # Offset to environment
        movl    %eax,(__environ)        # Set environment pointer
        movl    %edx,(__funct)          # Set atexit() function
1:      cmpl    $0x00, (%eax)           # Check for a NULL
        leal    0x04(%eax), %eax        # Ready next
        jnz     1b                      # Continue
        movl    %eax,(__auxv)           # Set aux vector
        andl    $0xfffffff0, %esp       # Align the stack-pointer
        subl    $0x04, %esp             # Room for errno
        movl    %esp, (__errnop)        # Errno pointer
        movl    %esp,(__libc_stack_end) # Set stack-end pointer
        pushl   $0x00                   # Zero on the stack
        pushl   %esp                    # Provide highest stack address
        pushl   %edx                    # Push address of the term function
        pushl   (__environ)             # Push environment pointer
        pushl   %ecx                    # Push argv[].
        pushl   %ebx                    # Push argc
        pushl   $0                      # Get current address to use
        call    brk                     # Ask Linux to do it
        addl    $0x04, %esp             # Level stack
        movl    %eax, (__brk_addr)      # Save that address
        call    __setup_stdio           # Set up descriptors
        pushl   $0                      # Null pointer
        call    time                    # Get current time
        pushl   %eax                    # Put it on the stack
        call    srand                   # Whatever is on the stack!
        addl    $0x08, %esp             # Level stack
        finit                           # Initialize FPU
        movl    %esp, (__main_stack)    # Save current stack pointer
__rest: movl    (__main_stack), %esp    # Get saved stack pointer
        call    main                    # Address of main
        pushl   %eax                    # Return code from main()
        call    exit                    # In case of a return
.size   _start,.-_start
.type   _start,@function
.global _start
.size   __rest,.-__rest
.type   __rest,@function
.global __rest
#-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
.section .rodata
_fp_hw: .long 3
.size   _fp_hw,.-_fp_hw
.type   _fp_hd,@object
.global _fp_hw
#-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
.section        .bss
__data_start:           .long   0
.size   __data_start,.-__data_start
.type   __data_start,@object
.global __data_start
__errnop:               .long   0
.size   __errnop,.-__errnop
.type   __errnop,@object
.global __errnop
__h_errno_location:	.long	0
.size	__h_errno_location,. -__h_errno_location
.type	__h_errno_location,@object
.global	__h_errno_location
stdin:                  .long   0
.size   stdin,.-stdin
.type   stdin,@object
.global stdin
stdout:                 .long   0
.size   stdout,.-stdout
.type   stdout,@object
.global stdout
stderr:                 .long   0
.size   stderr,.-stderr
.type   stderr,@object
.global stderr
__tok:                  .long   0
.size   __tok,.-__tok
.type   __tok,@object
.global __tok
__brk_addr:             .long   0
.size   __brk_addr,.-__brk_addr
.type   __brk_addr,@object
.global __brk_addr
__environ:              .long   0
.size   __environ,.-__environ
.type   __environ,@object
.global __environ
__auxv:                 .long   0
.size   __auxv,.-__auxv
.type   __auxv,@object
.global __auxv
__libc_stack_end:       .long   0
.size   __libc_stack_end,.-__libc_stack_end
__main_stack:           .long   0
.type   __libc_stack_end,@object
.global __libc_stack_end
.weak data_start
      data_start = __data_start

#-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#
#       These are for the addresses registered by atexit(). I allow
#       up to 8 such functions to be called before exit();
#
__funct:        .long   0, 0, 0, 0, 0, 0, 0, 0  # 8 functions to register
.size   __funct,.-__funct
.type   __funct,@object
.global __funct
__funct_end:    .long   0
.size   __funct_end,.-__funct_end
.type   __funct_end,@object
.global __funct_end
.end
#-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
