#-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#
#  Copyright(c)  2005  Richard B. Johnson
#
#  This program may be distributed under the GNU Public License
#  version 2, as published by the Free Software Foundation, Inc.,
#  59 Temple Place, Suite 330 Boston, MA, 02111.
#
#-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

.section        .text
STR1 = 0x0c
STR2 = 0x10

.global strcasecmp
.type   strcasecmp,@function
strcasecmp:
        pushl   %esi
        pushl   %edi
        movl    STR1(%esp), %esi        # Point to one string
        movl    STR2(%esp), %edi        # Point to the other string
        xorl    %eax,%eax               # Zero return value
1:      movb    (%esi), %dl             # Get one byte
        movb    (%edi), %dh             # Get the other byte
        leal    0x01(%esi), %esi        # Ready next location
        leal    0x01(%edi), %edi        # Ready next location
        andw    $0x5f5f, %dx            # Wipe away a-z A-Z difference
        jz      2f                      # All done
        testb   %dl, %dh                # See if one is zero
        jz      2f                      # All done
        cmpb    %dh, %dl                # Check values
        jz      1b                      # They compare, continue
        sbbl    $0, %eax                # Carry makes -1
        js      2f                      # Done, sign-bit was set
        incl    %eax                    # Other possibility
2:      popl    %edi
        popl    %esi
        ret

.size   strcasecmp,.-strcasecmp
#-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
STR1 = 0x0c
STR2 = 0x10
SLEN = 0x14

.global strncasecmp
.type   strncasecmp,@function
strncasecmp:
        pushl   %esi
        pushl   %edi
        movl    STR1(%esp), %esi        # Point to one string
        movl    STR2(%esp), %edi        # Point to the other string
        movl    SLEN(%esp), %ecx        # Get count
        xorl    %eax,%eax               # Zero return value
1:      decl    %ecx                    # Bump count
        js      2f                      # All done
        movb    (%esi), %dl             # Get one byte
        movb    (%edi), %dh             # Get the other byte
        leal    0x01(%esi), %esi        # Ready next location
        leal    0x01(%edi), %edi        # Ready next location
        andw    $0x5f5f, %dx            # Wipe away a-z A-Z difference
        jz      2f                      # All done
        testb   %dl, %dh                # See if one is zero
        jz      2f                      # All done
        cmpb    %dh, %dl                # Check values
        jz      1b                      # They compare, continue
        sbbl    $0, %eax                # Carry makes -1
        js      2f                      # Done, sign-bit was set
        incl    %eax                    # Other possibility
2:      popl    %edi
        popl    %esi
        ret
.size   strncasecmp,.-strncasecmp
.end
#-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
#-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
