//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//
//  Copyright(c)  2005  Richard B. Johnson
//
//  This program may be distributed under the GNU Public License
//  version 2, as published by the Free Software Foundation, Inc.,
//  59 Temple Place, Suite 330 Boston, MA, 02111.
//
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

//
//  File: chk_stat.c    Created 16-NOV-2002     Richard B. Johnson
//

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/fcntl.h>
#include <sys/stat.h>
static const char fname[]="/tmp/testing.txt";
#define FAIL -1
#define BUF_LEN 0x10000

#define ERRORS(s) \
{                 \
    fprintf(stderr, "Error from line %d, file %s, call %s, (%s)\n", \
    __LINE__,__FILE__,(s), strerror(errno)); \
    exit(EXIT_FAILURE); \
}


int main()
{
    char buf[BUF_LEN];
    struct stat sb;
    int fd;
    bzero(buf, BUF_LEN);
    if((fd = open(fname, O_RDWR|O_TRUNC|O_CREAT, 0644)) == FAIL)
        ERRORS("open");
    if(write(fd, buf, BUF_LEN) != BUF_LEN)
        ERRORS("write");
    if(fstat(fd, &sb) == FAIL)
        ERRORS("fstat");
    if(sb.st_size != BUF_LEN)
        fprintf(stderr, "Error : st_size = %lu\n", sb.st_size);
    if(lseek(fd, 0, SEEK_END) != BUF_LEN)
        ERRORS("lseek");
    if(close(fd) == FAIL)
        ERRORS("close");
    if(stat(fname, &sb) == FAIL)
        ERRORS("stat");
    if(sb.st_size != BUF_LEN)
        fprintf(stderr, "Error : st_size = %lu\n", sb.st_size);
    if(lstat(fname, &sb) == FAIL)
        ERRORS("lstat");
    if(sb.st_size != BUF_LEN)
        fprintf(stderr, "Error : st_size = %lu\n", sb.st_size);
    if(unlink(fname) == FAIL)
        ERRORS("unlink");
    return 0;
}
