//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//
//    File inet_addr.c  Created 12-MAR-2009       Richard B. Johnson
//
//    Copyright(c) 2009         Richard B. Johnson
//
//   Note that this is SUPPOSED to take a "dotted-quad" address
//   and return a binary value of type in_addr_t. However, the
//   caller might also just input a host name! This has been
//   okay with some runtime libraries so we need to make it okay
//   here as well.
//

#include <stdio.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

extern in_addr_t makeaddr(const char *cp);

in_addr_t inet_addr(const char *cp)
{
    struct hostent *hp;
    if((hp = gethostbyname(cp)) == NULL)
        return -1;
    return makeaddr(hp->h_addr_list[0]);
}
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

