//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//
//  Copyright(c)  2005  Richard B. Johnson
//
//  This program may be distributed under the GNU Public License
//  version 2, as published by the Free Software Foundation, Inc.,
//  59 Temple Place, Suite 330 Boston, MA, 02111.
//
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
/*
 *   This makes an ASCII string out of a long-long. If the
 *   base is negative, lower-case letters are used. If the
 *   input value is negative, a minus sign is written before
 *   the number.
 */

extern const char __small_num[];
extern const char __large_num[];
extern int __lldiv(long long *, int base);

char *makeascii(char *buf, long long value, int base)
{
    char tmp[0x30];
    char *cp = tmp;
    char *bp = buf;
    const char *ccp = __large_num;
    if(value < 0)
    {
        *bp++ = (char) '-';
        value = -value;
    }
    if(base < 0)
    {
        ccp  = __small_num;
        base = -base;
    }
    if(base > 0x10)
        base = 0x10;
    while(value)
        *cp++ = ccp[__lldiv(&value, base)];
    while(cp > tmp)
        *bp++ = *(--cp);
    *bp = 0x00;
    return bp;
}

