
#include <string.h>

extern char *__tok;       /* Saved in the bss segment somewhere */

/*
 *   June, 2003          Richard B. Johnson
 *
 *   This is an 'incorrect' version of strtok.
 *   strtok() is supposed to return a NULL if the delimiter is
 *   not found. This version returns the string itself. This
 *   is necessary to have strtok() work properly in real-world
 *   operations without additional code. Also, if you follow
 *   the specification in the SYS-V man pages, you will not
 *   get the last token in the string because, of course, no
 *   delimiter exists in the last token. This code also fixes
 *   than problem.
 */
char *strtok(char *str, const char *delim)
{
    char *cp;
    if(str != NULL)
    {
        if((__tok = strchr(str, *delim)) != NULL)
            *__tok++ = (char) 0x00;
        return str;
    }
    if((cp = __tok) != NULL)
        if((__tok = strchr(__tok, *delim)) != NULL)
            *__tok++ = (char) 0x00;
    return cp;
}


