#include <stdio.h>
#include <unistd.h>
#include <termios.h>
#include <malloc.h>
#include <string.h>

#define INP_LEN  0x80
char *cp = NULL;

char *getpass(const char *prompt)
{
    size_t len;
    int ret;
    struct termios start;
    struct termios noecho;
    if(cp == NULL)
        if((cp = malloc(INP_LEN)) == NULL)
            return cp;
    tcgetattr(STDIN_FILENO, &start);
    memcpy (&noecho, &start, sizeof(noecho)); 
    noecho.c_cflag &= ~ECHO;
    tcsetattr(STDIN_FILENO, TCSANOW, &noecho);
    len = strlen(prompt);
    (void)write(STDERR_FILENO, prompt, len);
    ret = read(STDIN_FILENO, cp, INP_LEN);
    if(ret >= 0)
        cp[ret] = (char) 0x00;
    else
        cp[0] = (char) 0x00;
    if(*cp == (char) '\n')
        *cp = (char) 0x00;
    tcsetattr(STDIN_FILENO, TCSANOW, &start);
    return cp;
}

