//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//
//  Copyright(c)  2005  Richard B. Johnson
//
//  This program may be distributed under the GNU Public License
//  version 2, as published by the Free Software Foundation, Inc.,
//  59 Temple Place, Suite 330 Boston, MA, 02111.
//
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

#include <errno.h>
#include <sys/msg.h>
#include "ipc.h"


//
// Message queue control operation
//
int msgctl (int msqid, int cmd, struct msqid_ds *buf)
{
    return __ipc(IPCOP_msgctl ,msqid ,cmd ,0 ,buf);
}
//
// Get messages queue.
//
int msgget(key_t key, int msgflg)
{
    return __ipc(IPCOP_msgget ,key ,msgflg ,0 ,0);
}

struct new_msg_buf{
    struct msgbuf * oldmsg;
    long int r_msgtyp;
};
//
// Receive message from message queue
//
int msgrcv(int msqid, void *msgp, size_t msgsz, long int msgtyp, int msgflg)
{
    struct new_msg_buf temp;

    temp.r_msgtyp = msgtyp;
    temp.oldmsg = msgp;
    return __ipc(IPCOP_msgrcv ,msqid ,msgsz ,msgflg ,&temp);
}
//
// Send message to message queue
//
int msgsnd (int msqid, const void *msgp, size_t msgsz, int msgflg)
{
    return __ipc(IPCOP_msgsnd, msqid, msgsz, msgflg, (void *)msgp);
}

