//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//
//  Copyright(c)  2005  Richard B. Johnson
//
//  This program may be distributed under the GNU Public License
//  version 2, as published by the Free Software Foundation, Inc.,
//  59 Temple Place, Suite 330 Boston, MA, 02111.
//
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=


#include <errno.h>
#include <sys/sem.h>
#include <stdarg.h>
#define NULL (void *)0
#include "ipc.h"
//
// For semctl system calls
//
union semun {
    int val;                            // Value for SETVAL
    struct semid_ds *buf;               // For IPC_STAT and IPC_SET
    unsigned short *array;              // For GETALL and SETALL
    struct seminfo *__buf;              // For IPC_INFO
    void *__pad;
};

int semctl(int semid, int semnum, int cmd, ...)
{
    union semun arg;
    va_list ap;

    va_start (ap, cmd);
    arg = va_arg (ap, union semun);
    va_end (ap);
    return __ipc(IPCOP_semctl, semid, semnum, cmd, &arg);
}

int semget (key_t key, int nsems, int semflg)
{
    return __ipc(IPCOP_semget, key, nsems, semflg, NULL);
}

//
// Perform user-defined atomic operation of array of semaphores.
//
int semop(int semid, struct sembuf *sops, size_t nsops)
{
    return __ipc(IPCOP_semop, semid, (int) nsops, 0, sops);
}


