//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//
//  Copyright(c)  2005  Richard B. Johnson
//
//  This program may be distributed under the GNU Public License
//  version 2, as published by the Free Software Foundation, Inc.,
//  59 Temple Place, Suite 330 Boston, MA, 02111.
//
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#define BUF_SIZE 0x1000


const char fname[]="ctypes.s";

#define MAX_LEN 384
#define NAME file

int main(int unused, char *argv[])
{
    FILE *file;
    char *buf;
    size_t i, j;
    const unsigned short *ctype_b;
    const int32_t *ctype_tolower;
    const int32_t *ctype_toupper;

#ifdef USE_GLOBAL
    ctype_b       = __ctype_b;
    ctype_tolower = __ctype_tolower;
    ctype_toupper = __ctype_toupper;
#else
    ctype_b       = *__ctype_b_loc();
    ctype_tolower = *__ctype_tolower_loc();
    ctype_toupper = *__ctype_toupper_loc();
#endif

    if((buf = (char*) malloc(BUF_SIZE)) == NULL)
    {
        fprintf(stderr, "Memory allocation error\n");
        exit(EXIT_FAILURE);
    }
    if((file = fopen(fname, "w")) == NULL)
    {
        free(buf);
        fprintf(stderr, "Can't create file %s\n", fname);
        exit(EXIT_FAILURE);
    }
    fprintf(NAME, "#\n");
    fprintf(NAME, "# Created by %s\n", argv[0]);
    fprintf(NAME, "#\n");
    fprintf(NAME, ".section\t.rodata\n");
    fprintf(NAME, ".align\t0x04\n");
    fprintf(NAME, ".global\t__ctype_b\n");
    fprintf(NAME, ".type\t__ctype_b,@object\n");
    fprintf(NAME, "__ctype_b:\t.long\t.L1\n");
    fprintf(NAME, ".size\t__ctype_b,%d\n",sizeof(long));
    fprintf(NAME, ".align\t0x04\n");
    fprintf(NAME, ".L1:\n");
    for(i=0; i< MAX_LEN; i += 8)
    {
        fprintf(NAME,"\t.word ");
        for(j=0; j< 0x08; j++)
        {
            if(j < 7)
                fprintf(NAME, "0x%04x,", ctype_b[i+j]);
            else
                fprintf(NAME, "0x%04x\n", ctype_b[i+j]);
        }
    }
    fprintf(NAME, ".size\t.L1,%d\n", MAX_LEN * sizeof(short));
    fprintf(NAME, ".global\t__ctype_tolower\n");
    fprintf(NAME, ".type\t__ctype_tolower,@object\n");
    fprintf(NAME, "__ctype_tolower:\t.long\t.L2\n");
    fprintf(NAME, ".size\t__ctype_tolower,%d\n", sizeof(long));
    fprintf(NAME, ".L2:\n");
    for(i=0; i< MAX_LEN; i += 8)
    {
        fprintf(NAME,"\t.long ");
        for(j=0; j< 0x08; j++)
        {
            if(j < 7)
                fprintf(NAME, "0x%04x,", ctype_tolower[i+j]);
            else
                fprintf(NAME, "0x%04x\n", ctype_tolower[i+j]);
        }
    }
    fprintf(NAME, ".size\t.L2,%d\n", MAX_LEN * sizeof(int));
    fprintf(NAME, ".global\t__ctype_toupper\n");
    fprintf(NAME, ".type\t__ctype_toupper,@object\n");
    fprintf(NAME, "__ctype_toupper:\t.long\t.L3\n");
    fprintf(NAME, ".size\t__ctype_toupper,%d\n", sizeof(long));
    fprintf(NAME, ".L3:\n");
    for(i=0; i< MAX_LEN; i += 8)
    {
        fprintf(NAME,"\t.long ");
        for(j=0; j< 0x08; j++)
        {
            if(j < 7)
                fprintf(NAME, "0x%04x,", ctype_toupper[i+j]);
            else
                fprintf(NAME, "0x%04x\n", ctype_toupper[i+j]);
        }
    }
    fprintf(NAME, ".size\t.L3,%d\n", MAX_LEN * sizeof(int));
    fprintf(NAME, ".section\t.text\n");
    fprintf(NAME, ".global\t__ctype_toupper_loc\n");
    fprintf(NAME, ".type\t__ctype_toupper_loc,@function\n");
    fprintf(NAME, "__ctype_toupper_loc:\n");
    fprintf(NAME, "\tmovl\t$__ctype_toupper,%%eax\n");
    fprintf(NAME, "\tret\n");
    fprintf(NAME, ".global\t__ctype_tolower_loc\n");
    fprintf(NAME, ".type\t__ctype_tolower_loc,@function\n");
    fprintf(NAME, "__ctype_tolower_loc:\n");
    fprintf(NAME, "\tmovl\t$__ctype_tolower,%%eax\n");
    fprintf(NAME, "\tret\n");
    fprintf(NAME, ".global\t__ctype_b_loc\n");
    fprintf(NAME, ".type\t__ctype_b_loc,@function\n");
    fprintf(NAME, "__ctype_b_loc:\n");
    fprintf(NAME, "\tmovl\t$__ctype_b,%%eax\n");
    fprintf(NAME, "\tret\n");
    fprintf(NAME,".end\n");
    fclose(file);
    free(buf);
    return 0;
}

