//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
//
//  Copyright(c)  2005  Richard B. Johnson
//
//  This program may be distributed under the GNU Public License
//  version 2, as published by the Free Software Foundation, Inc.,
//  59 Temple Place, Suite 330 Boston, MA, 02111.
//
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <ctype.h>
#include <string.h>


#define READ_LEN 0x0800
#define NAME_LEN 0x0100
#define VALU_LEN 0x0100
#define BUF_LEN  (READ_LEN + NAME_LEN + VALU_LEN)

int main(int args, char *argv[])
{
    FILE *infile;
    FILE *outfile;
    char *buf;
    char *cp;
    char *call_name;
    char *call_value;
    if(args < 3)
    {
        fprintf(stderr, "Usage:\n%s <infile> <outfile>\n", argv[0]);
        exit(EXIT_FAILURE);
    }
    if((infile = fopen(argv[1], "r")) == NULL)
    {
        fprintf(stderr, "Can't open %s for reading\n", argv[1]);
        exit(EXIT_FAILURE);
    }
    if((outfile = fopen(argv[2], "w")) == NULL)
    {
        fprintf(stderr, "Can't open %s for writing\n", argv[2]);
        fclose(infile);
        exit(EXIT_FAILURE);
    }
    if((buf = (char *)malloc(BUF_LEN * sizeof(char))) == NULL)
    {
        fprintf(stderr, "Can't allocate memory\n");
        fclose(infile);
        fclose(outfile);
        remove(argv[2]);
        exit(EXIT_FAILURE);
    }
    call_name  = buf + READ_LEN;
    call_value = call_name + NAME_LEN;
    while(fgets(buf, READ_LEN, infile) != NULL)
    {
        if((cp = strstr(buf, "__NR_")) != NULL)
            if(strstr(cp, "##") == NULL)
                if(sscanf(cp, "%s %s", call_name, call_value) == 2)
                    if(isdigit(*call_value))
                        fprintf(outfile, "%s = %s\n", call_name, call_value);
    }
    free(buf);
    fclose(infile);
    fclose(outfile);
    return 0;
}
