#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <malloc.h>

#define BUF_LEN 0x800

static const char find[]="rjohnson@analogic.com";
static const char replace[]="RichardBJohnson@comcast.net\n";

static const char usage[]="Usage:\n%s <infile> <outfile>\n";

int main(int args, char *argv[])
{
    char *inbuf, *outbuf;
    FILE *infile, *outfile;
    char *ip, *op, *cp, c;
    if(args < 3)
    {
        fprintf(stderr, usage, argv[0]);
        exit(EXIT_FAILURE);
    }
    if((inbuf = malloc(BUF_LEN)) == NULL)
    {
        fprintf(stderr,"Can't allocate memory\n");
        exit(EXIT_FAILURE);
    }
    if((outbuf = malloc(BUF_LEN)) == NULL)
    {
        fprintf(stderr,"Can't allocate memory\n");
        free(inbuf);
        exit(EXIT_FAILURE);
    }
    if((infile = fopen(argv[1], "r")) == NULL)
    {
        fprintf(stderr,"Can't open %s for reading\n", argv[1]);
        free(outbuf);
        free(inbuf);
        exit(EXIT_FAILURE);
    }
    (void)unlink(argv[2]);
    if((outfile = fopen(argv[2], "w")) == NULL)
    {
        fprintf(stderr,"Can't open %s for writing\n", argv[2]);
        fclose(infile);
        free(outbuf);
        free(inbuf);
        exit(EXIT_FAILURE);
    }
    while(fgets(inbuf, BUF_LEN, infile) != NULL)
    {
        if((cp = strstr(inbuf, find)) != NULL)
            strcpy(cp, replace); 
        op = outbuf;
        ip = inbuf;
        do {
            c = *ip++;
            *op++ = c;
            if(c == (char) '%')
               *op++ = c;
           } while (c);
   
        (void)fprintf(outfile, outbuf);
    }
    fclose(infile);
    fclose(outfile);
    free(inbuf);
    free(outbuf);
    return 0;
}

